#!/bin/sh
# USBKey unlock script
# Mounting the partition.

COUNT=0

while [ "$COUNT" -lt 5 ]; do
	COUNT=`expr $COUNT + 1`
	sleep 5 # let the drive settle

	if [ -b /dev/usbkey ]; then
		/sbin/cryptsetup luksOpen --key-file=/root/usb/file.key /dev/usbkey usbkey
		PHASE=1
		COUNT=5
	elif [ "$COUNT" = "5" ]; then
		PHASE=0
		echo "`date` Can't find drive." >> /root/usb/access.log 
        fi
done

if [ "$PHASE" = "1" ]; then
	if [ -d /mnt/usbkey ]; then
		/bin/mount -o uid=0,gid=0,umask=0177 /dev/mapper/usbkey /mnt/usbkey
	elif [ -d /mnt ]; then
		/bin/mkdir /mnt/usbkey
		/bin/mount -o uid=0,gid=0,umask=0177 /dev/mapper/usbkey /mnt/usbkey 
	fi 

# Checking the hash value on the usbkey vs the passcode.

	pass=`sha512sum -c /mnt/usbkey/0|tail -n 1|awk '{print $2}'`

# Logining you in, change 'itzhak' to your own username.

	if [ "$pass" = "OK" ]; then

		user=`ps aux | grep gnome-screensaver | head -n 1 | awk '{print $1}'`

		if [ "$user" = "lightdm" -o "$user" = "root" ]; then
	        	/usr/bin/service lightdm stop
	        	su itzhak -c "startx"

		elif [ -n $user ]; then
		        GNOME_SCREENSAVER_PROC=`ps xa | grep gnome-screensaver | head -n 1 | awk '{print $1}'`
		        export `grep -z DBUS_SESSION_BUS_ADDRESS /proc/$GNOME_SCREENSAVER_PROC/environ`
 
		        su $user -c "qdbus org.gnome.ScreenSaver / SetActive false"
		fi

# Genereting a new hash and passcode for the next login.

		/bin/dd bs=4096 count=4 if=/dev/urandom of=/root/usb/passcode
		sha512sum /root/usb/passcode > /mnt/usbkey/0

# Closing the partition

	        /bin/umount /mnt/usbkey
		/sbin/cryptsetup luksClose usbkey

# If the passcode miss-match the hash,
# log and unmount

	else
		echo "`date` Some kind of error accoured." >> /root/usb/access.log
	        /bin/umount /mnt/usbkey
		/sbin/cryptsetup luksClose usbkey
	fi
fi
